/************************************************************************
 ***           Beispielprogramm fr PC-Steckkarte DA 1256             ***
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

void write_board(int voltage, int channel);
void main_menu(void);
void clear_screen(void);
void write_position(int x,int y,char *text,int attr);
void out_current(int c);

int address=0x100;                      /* Portadresse der DA-Karte     */
float max_ma=20;                        /* Ausgangsspannungsbereich 0-20mA */
int key,i;                              /* Globale Hilfsvariablen       */
char key_input[20];

/************************************************************************
 ***                Hauptprogramm                                     ***
 ************************************************************************/
int main(void)
{
  int i;                                /* lokale Hilfsvariable         */
  clear_screen();                       /* Bildschirm lschen           */
  _setcursortype(_NOCURSOR);            /* Cursor aus                   */
  main_menu();                          /* Hauptmenu darstellen         */
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste F1-F8 oder F10 gedrckt */
      i=kbhit();
      if (i!=0)                         /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    key=getch();                /* Scan-Code holen              */
	  switch (key)
	    {
	      case 59:{                 /* Bei F1 : Strom Kanal 0    */
					/* ausgeben                     */
			out_current(0);
			break;
		      }
	      case 60:{                 /* Bei F2 : Strom Kanal 1    */
					/* ausgeben                     */
			out_current(1);
			break;
		      }
	      case 61:{                 /* Bei F3 : Strom Kanal 2    */
					/* ausgeben                     */
			out_current(2);
			break;
		      }

	      case 62:{                 /* Bei F4 : Strom Kanal 3    */
					/* ausgeben                     */
			out_current(3);
			break;
		      }

	      case 63:{                 /* Bei F5 : Strom Kanal 4    */
					/* ausgeben                     */
			out_current(4);
			break;
		      }
	      case 64:{                 /* Bei F3 : Strom Kanal 5    */
					/* ausgeben                     */
			out_current(5);
			break;
		      }

	      case 65:{                 /* Bei F4 : Strom Kanal 6    */
					/* ausgeben                     */
			out_current(6);
			break;
		      }

	      case 66:{                 /* Bei F5 : Strom Kanal 7    */
					/* ausgeben                     */
			out_current(7);
			break;
		      }
	    }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */
  for (i=0;i<=7;i++)
    write_board(0,i);
  textattr(0x07);
  clrscr();
  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
  return 0;
}

/************************************************************************
 ***                Unterprogramme fr DA 1256                        ***
 ************************************************************************/

void write_board(int current, int channel) /* Gibt den Spannungswert aus   */
{
  outportb(address,(current & 0xFF));      /* untere 8 Bits                */
  outportb(address+1,((current >> 8) + (channel << 4)));  /* untere 4 Bit  */

}

/************************************************************************
 ***                   Unterprogramme                                 ***
 ************************************************************************/

void out_current(int c)                 /* Strom ausgeben            */
{
  float wert;                           /* Lokale Hilfsvariable         */

  clear_screen();                       /* Eingabe Spannungswert        */
  write_position(20,12,"Bitte geben Sie den Wert an : ",1);
  _setcursortype(_SOLIDCURSOR);
  cscanf("%s",&key_input);
  _setcursortype(_NOCURSOR);
					/* Komma und Dezimalpunkt erlaubt */
  for (i=0;i<=20;i++)
    {
      if (key_input[i]==',')
	key_input[i]='.';
      if (key_input[i]=='\0')
	break;
    }
  wert=atof(key_input);                 /* Wert wandeln in Integer      */
  i=abs(wert*(4095/max_ma));
  if (i<=4095)                          /* Ausgabe erfolgt nur, wenn    */
    write_board(i,c);                   /* Bereich eingehalten wird     */
  clear_screen();                       /* Bildschirm lschen           */
  main_menu();                          /* Hauptmenu darstellen         */
  key=0;                                /* Tastendruck zurcksetzen     */
}

/************************************************************************/

void main_menu(void)                    /* Darstellung Hauptmenu        */
{
  char text1[]=" Kanal 0 = F1  ";
  char text2[]=" Kanal 1 = F2  ";
  char text3[]=" Kanal 2 = F3  ";
  char text4[]=" Kanal 3 = F4  ";
  char text5[]=" Kanal 4 = F5  ";
  char text6[]=" Kanal 5 = F6  ";
  char text7[]=" Kanal 6 = F7  ";
  char text8[]=" Kanal 7 = F8  ";
  char text9[]=" Ende    = F10 ";
  int x=30;
  int y=8;

  write_position(x,y,text1,1);
  write_position(x,y+2,text2,1);
  write_position(x,y+4,text3,1);
  write_position(x,y+6,text4,1);
  write_position(x,y+8,text5,1);
  write_position(x,y+10,text6,1);
  write_position(x,y+12,text7,1);
  write_position(x,y+14,text8,1);
  write_position(x,y+16,text9,1);

}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
     Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
     Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 7717 Immendingen ";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);
}


/************************************************************************/

void write_position(int x,int y,char *text,int attr)
{
  if (attr==0)
    textattr(0x10);
  if (attr==1)
    textattr(0x3E);
  gotoxy(x,y);
  cprintf(text);
}

